//  Copyright 2006,2007 Doug Campbell
//
//  This file is part of Cam-Scom.
//
//  Cam-Scom is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  Cam-Scom is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with Cam-Scom; if not, see <http://www.gnu.org/licenses/>.

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/select.h>

MODULE = Cam::Scom  PACKAGE = Cam::Scom

void
_mask_to_array_in_c (maskvar, maskbitlenvar)
    SV *maskvar
    SV *maskbitlenvar
  INIT:
    AV *intlist;
    int i;
    int maskbitlen;
    char *mask;
  PPCODE:
    maskbitlen = SvIV(maskbitlenvar);
    mask = SvPV (maskvar, PL_na);
    intlist = newAV();
    for (i = 0; i < maskbitlen; ++i)
    {
	if (FD_ISSET (i, (fd_set *) mask))
	{
	    av_push (intlist, newSViv (i));
	};
    };
    EXTEND (SP, 1);
    XPUSHs (sv_2mortal (newRV_noinc ((SV*) intlist)));

MODULE = Cam::Scom  PACKAGE = Cam::Scom

void
_fcntl_3arg_in_c (fdarg, cmdarg, argarg)
    SV *fdarg
    SV *cmdarg
    SV *argarg
  INIT:
    int fd;
    int cmd;
    long arg;
    int r;
  PPCODE:
    fd = SvIV(fdarg);
    cmd = SvIV(cmdarg);
    arg = (long) SvIV(argarg);
    r = fcntl (fd, cmd, arg);
    EXTEND (SP, 1);
    XPUSHs (sv_2mortal (newSViv (r)));
