#               -*-CPerl-*-
use strict;
use warnings;
use Module::Build;

my $systype = (-e "/etc/debian_version") ? "debian" :
  (-e "/etc/redhat-release") ? "redhat" : "unknown";

my $jscflags;
my $jslibflags;
if ($systype eq "redhat")
{
    chomp ($jscflags = `pkg-config --cflags mozilla-js`);
    chomp ($jslibflags = `pkg-config --libs mozilla-js`);
}
elsif ($systype eq "debian")
{
    chomp ($jscflags = `pkg-config --cflags xulrunner-js`);
    chomp ($jslibflags = `pkg-config --libs xulrunner-js`);
    $jscflags .= " -DMOZILLA_1_8_BRANCH";
}
else
{
    die ("Unknown platform: cannot compute jscflags");
};

my $builder = Module::Build->new(
    module_name         => 'Vxglue',
    license             => 'gpl',
    dist_author         => 'Doug Campbell <soup@ampersand.com>',
    dist_version_from   => 'lib/Vxglue.pm',
    extra_compiler_flags  => $jscflags,
    extra_linker_flags  => "-lSBjsiD -lSBtrdD -lSBcharD -lSBlogD -lSBlogMapperD -lSBcacheD -lSBinetD -lVXIvalueD -lVXID -lVXItelD -lVXIclientD -lVXIpromptD -lVXIrecD -lvglue " . $jslibflags . " -lstdc++ -lpthread -ldl",
    build_requires => {
        'Test::More' => 0,
    },
    add_to_cleanup      => [ 'Vxglue-*' ],
);

$builder->create_build_script();
